﻿using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Collections;
namespace BindingArrayList
{
    public class MyControlCellRender : GridGenericControlCellRenderer
    {
        MyControl control = new MyControl();      
        
        public MyControlCellRender(GridControlBase grid, GridCellModelBase cellModel)
            : base(grid, cellModel)
		{
            SetControl(control);
 		}       

 		protected override void Dispose(bool disposing)
		{
			if (disposing)
			{
                control.Dispose();
                control = null;
			}
			base.Dispose (disposing);
		}        
        protected override void OnDraw(Graphics g, Rectangle clientRectangle, int rowIndex, int colIndex, GridStyleInfo style)
        {
            try
            {
                style.Control = control;

                //**************************************************************
                //you need to set the text for custom cell in this place. 
                //Because for every time, this event will be called and the text for this cell can be assigned if we set LabelText.
                //So that the below way is the only possible method to assign the text as default.
                //control object is assigned for every cell in this place. You cannot access unique control object other than this place.
                //Hope you can understand.
                //**************************************************************
                
                if (style.CellIdentity is GridTableCellViewStyleInfoIdentity)
                {
                    GridTableCellViewStyleInfoIdentity id = style.CellIdentity as GridTableCellViewStyleInfoIdentity;
                    GridControlBase grid = id.GetActiveGridView() as GridControlBase;
                    if (grid is GridTableControl)
                    {
                        control.Update(id.DisplayElement.GetRecord().GetValue("val2").ToString());
                    }

                }
                base.OnDraw(g, clientRectangle, rowIndex, colIndex, style);
            }

            catch (Exception e)
            {
                Console.WriteLine("ERROR: " + e.Message);
            }
        }

        
    }
}
